; Tlcommande infrarouge, metteur,exemple d'application

; pour plus d'information consultez le site http://www.roboticus.org
; (c) http://www.roboticus.org
; rserv  une utilisation personnelle et dans un but non commercial et non
; lucratif.

    list   p=16f84a
    __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_OFF & _XT_OSC

    #include <p16f84a.inc>

compteur equ 0x20; pause
compteur2 equ 0x24
boucle equ 0x21; envoie des 8bits et pause de 40ms
cle equ 0x22; cle a envoy
tjrs equ 0x23; regarde si le bouton est toujours appuyer


    org 0x00
    goto setup

setup
    banksel TRISA
    movlw 0x00 ; toutes en sortie pour le moment
    movwf TRISA
    movlw H'FF' ; toutes en entre
    movwf TRISB
    movlw H'00'
    movwf OPTION_REG
    banksel PORTA
    clrf PORTA
    clrf PORTB

main
    movlw h'08';
    movwf boucle
    movlw h'09'
    movwf INTCON
    sleep
go  

    movf PORTB, w;
    movwf tjrs;

    btfss PORTB, 7
    goto tx1;
    btfss PORTB,4
    goto tx2;
    goto main;

tx2 movlw h'11';
    movwf cle
    goto tx

tx1  movlw h'01';
    movwf cle





tx
    call send1280 ; on ajoutera la cration de la cl
boucletx 
    btfsc cle, 7 
    goto send1
    call pause1280 ; envoie rien pendant 1280 cad qu'on envoie un 0
    goto endtx
send1:
    call pause640; envoie rien pendant 640 cad qu'on envoie un 1
    call send640; envoie pendant 640s des donnes
endtx: 
    rlf cle, 1 
    call send640; on envoie des donnes pendant 640s afin d'indiquer qu'un prochain bit va tre envoy
    decfsz boucle, 1
    goto boucletx; boucle pour envoyer les 8 bits
    call pause40000;
    movf tjrs,0 ;
    subwf PORTB,w
    btfsc STATUS,Z
    goto go
    goto main
    

send1280 ; pause plus longue que 1280s
    movlw h'35'
    movwf compteur
    goto bouclesend
send640
    movlw h'18'; on envoie des donnes pendant 640s
    movwf compteur
bouclesend   
       bsf PORTA, 0;
       nop
       nop         ; 3 s
       nop         ; 4 s
       nop         ; 5 s
       nop         ; 6 s
       nop         ; 7 s
       nop         ; 8 s
       nop         ; 9 s
       nop         ; 10 s
       nop         ; 11 s
       nop         ; 12 s
       nop         ; 13 s
       nop
       bcf PORTA, 0;
       nop         ; 2 s
       nop         ; 3 s
       nop         ; 4 s
       nop         ; 5 s
       nop         ; 6 s
       nop
       nop
       nop
       nop
       nop
       decfsz compteur,F
       goto bouclesend
       return

pause1280    ; pause de 1280sec exactement
    movlw h'FF';
    movwf compteur;
    call pause;
    return

pause640        ; pause de 640 sec exactement
    movlw h'7C';
    movwf compteur;
    call pause;
    return

    
pause ; boucle de 5sec
    nop
    nop
    decfsz compteur,F
    goto pause
    return


pause40000:        ; pause de 40ms, cad le temps de recevoir 2 fois les informations afin d'tre sur de pas se tromper
    movlw h'c8'
    movwf compteur ; premiere variable
    movlw h'32'
    movwf compteur2 
pausebcl:
    nop
    decfsz compteur, 1
    goto pausebcl
    movlw h'c8'
    movwf compteur ; premiere variable
    decfsz compteur2, 1
    goto pausebcl
    return


    end
